% Continuous Time Markov Chain
% SIR Epidemic Model
clear
close all
global beta b gam N
beta=7;
b=4.25;
gam=1.25;
N=105;
init=5;
time=10;
sim=1;
cola=ceil(.05*N);
for k=1:sim
    clear t s i
       t(1)=0;
       s(1)=floor(N*.1);
       i(1)=floor(N*.8);
       scrsz = get(0,'ScreenSize');
       figure('Position',[1 scrsz(4)/2 scrsz(3)/2 scrsz(4)/2],'MenuBar','none')
       axis([0 1 0 1])
       xlabel('Susceptible','FontSize',12)
       ylabel('Infected','FontSize',12,'Rotation',90,'HorizontalAlignment','center')
       S=['N = ',num2str(N)];
       title(S)
       hold on
       [tt,y]=ode45('odesir',[0 time],[s(1) i(1)])
       plot(y(:,1)/N,y(:,2)/N,'r','LineWidth',2)
       line([0 1],[1 0])
       j=1;
       while i(j)>-1 & t(j)<time
           q1=beta*i(j)*s(j)/N;
           q2=gam*i(j);
           q3=b*i(j);
           q4=b*(N-s(j)-i(j));
           a=q1+q2+q3+q4;
           if a==0
               jnew=floor(j*rand);
               i(j)=i(jnew);
               s(j)=s(jnew);
               q1=beta*i(j)*s(j)/N;
               q2=gam*i(j);
               q3=b*i(j);
               q4=b*(N-s(j)-i(j));
               a=q1+q2+q3+q4;
               j=j-1;
           else
           u1=rand; % uniform random number
           u2=rand; % uniform random number
           t(j+1)=t(j)-log(u1)/a;
           if u2 <= q1/a
               i(j+1)=i(j)+1;
               s(j+1)=s(j)-1;
           elseif u2<=(q1+q2)/a
               i(j+1)=i(j)-1;
               s(j+1)=s(j);
           elseif u2<=(q1+q2+q3)/a
               i(j+1)=i(j)-1;
               s(j+1)=s(j)+1;
           else
               i(j+1)=i(j);
               s(j+1)=s(j)+1;
           end
           end
           plot(s(j)/N,i(j)/N,'s','MarkerFaceColor','g','MarkerEdgeColor','k','LineWidth',1+10/N)
           drawnow
           pause(1/N)
           if j>cola
           plot(s(j-cola)/N,i(j-cola)/N,'s','MarkerFaceColor','r','MarkerEdgeColor','k','LineWidth',1+10/N)
           hold on
           end
           j=j+1;
       end
%       plot(i,s)
 %      pause
       hold on
end
figure('Position',[scrsz(3)/2 scrsz(4)/2 scrsz(3)/2 scrsz(4)/2],'MenuBar','none')
hold on
plot(t,i/N,t,s/N)
legend('susceptible','infected')
pause
plot(tt,y(:,1)/N,'--',tt,y(:,2)/N,'--')
%figure('Position',[1 1 scrsz(3)/2 scrsz(4)/2],'MenuBar','none')
%hold on
[fs,xs]=ksdensity(s/N);
[fi,xi]=ksdensity(i/N);
fi=(fi/max(fi))*max(tt);
fs=fs/max(fs)*max(tt);
pause
plot(fs,xs,fi,xi);